on *:load: echo Type /musictest to start a game and start testing your knowledge!
alias -l drawbutton {
  drawrect $1 1 1 $2-5
  drawrect -fr $1 $rgb(face) 1 $calc($2 + 2) $calc($3 + 2) $calc($4 - 3) $calc($5 - 3)
  drawline -r $1 $rgb(hilight) 1 $calc($2 + 1) $calc($3 + $5 - 2) $calc($2 + 1) $calc($3 + 1) $calc($2 + $4 - 2) $calc($3 + 1)
  drawline -r $1 $rgb(shadow) 1 $calc($2 + 1) $calc($3 + $5 - 2) $calc($2 + $4 - 2) $calc($3 + $5 - 2) $calc($2 + $4 - 2) $3
  drawtext -r $1 $rgb(text) $10 $11 $round($calc($2 + (($4 - $width($12-,$10,$11)) / 2)),0) $round($calc($3 + (($5 - $height($12-,$10,$11)) / 2)),0) $12-
}
alias musictest {
  window -pCdf @MusicTest 1 1 200 136
  drawfill -r @musictest $rgb(255,255,255) $rgb(255,255,255) 0 0
  drawpbar -pr @musictest 13 4 105 9 0 0 0 $rgb(0,0,0) $rgb(255,255,255) $rgb(0,0,0) $rgb(128,128,128) $rgb(208,208,208)
  drawtext -ro @musictest $rgb(0,0,0) tahoma 10 126 2 Points:
  drawtext -ro @musictest $rgb(0,0,0) tahoma 10 180 2 $chr(150)
  drawline -r @musictest $rgb(0,0,0) 1 7 17 192 17
  drawline -ro @musictest $rgb(0,0,0) 1 7 82 192 82
  drawtext -ro @musictest $rgb(0,0,0) tahoma 10 $calc(100 - ($width(Score: 0 (0/0),tahoma,10) / 2)) 84 Score: 0 (0/0)
  drawline -ro @musictest $rgb(0,0,0) 1 7 98 192 98
  drawbutton @musictest 13 101 80 13 14215660 16777215 10070188 0 tahoma 9 new game
  drawbutton @musictest 103 101 80 13 14215660 16777215 10070188 0 tahoma 9 close
  drawbutton @musictest 170 116 13 13 14215660 16777215 10070188 0 webdings 9 s
  drawline -ro @musictest $rgb(0,0,0) 1 13 129 163 129
  if (%musict.sfile) drawtext -ro @musictest $rgb(0,0,0) tahoma 10 13 116 $mt.write-pl($ifmatch,135)
}
menu @musictest {
  sclick:{
    if ($inrect($mouse.x,$mouse.y,103,101,80,13)) { close -@ @musictest | mt.close }
    if ($inrect($mouse.x,$mouse.y,170,116,13,13)) {
      set %musict.sfile $sfile($iif($nofile(%musict.sfile),$nofile(%musict.sfile),$mircdir) *.m3u;,Select a Playlist File,Select)
      drawtext -ro @musictest $rgb(0,0,0) tahoma 10 13 116 $mt.write-pl(%musict.sfile,135)
    }
    if ($inrect($mouse.x,$mouse.y,13,101,80,13)) {
      if (%musict.sfile) {
        mt.pl-info $ifmatch
        drawrect -fr @musictest $rgb(255,255,255) 1 164 2 50 12
        drawtext -ro @musictest $rgb(0,250,0) tahoma 10 162 2 1000
        .timermusict off
        unset %mt.total %mt.right %mt.ques
        .timermtstart -m 1 500 mt.rnd-start
      }
      else var %temp = $input(You must select a playlist file before starting a game.,agow,Error!)
    }
    if ($inrect($mouse.x,$mouse.y,13,19,175,60)) && ($calc(($mouse.y - 7) / 12 - 1) <= $mt.pl-info(0)) && ($timer(musict)) {
      var %x = $int($calc(($mouse.y - 7) / 12))
      mt.ques-ans $iif(%x != %mt.correct,1)
    }
  }
  mouse:{
    if ($inrect($mouse.x,$mouse.y,13,19,175,60)) && ($calc(($mouse.y - 7) / 12 - 1) <= $mt.pl-info(0)) && ($timer(musict)) {
      var %x = $int($calc(($mouse.y - 7) / 12))
      if (%x != %mt.mouse-num) {
        if (%mt.mouse-num) {
          drawrect -rf @musictest $rgb(255,255,255) 1 13 $calc(7 + %mt.mouse-num * 12) 175 12
          drawtext -ro @musictest $rgb(0,0,0) tahoma 10 13 $calc(7 + %mt.mouse-num * 12) $mt.write-pl($+(%mt.mouse-num,.) $mt.pl-info($gettok(%mt.nums,%mt.mouse-num,32)).title,155)
        }
        set %mt.mouse-num %x
        drawrect -rf @musictest $rgb(0,0,0) 1 13 $calc(7 + %x * 12) 175 12
        drawtext -ro @musictest $rgb(255,255,255) tahoma 10 13 $calc(7 + %x * 12) $mt.write-pl($+(%x,.) $mt.pl-info($gettok(%mt.nums,%x,32)).title,155)
      }
    }
  }
}
on *:KEYDOWN:@musictest:*: if ($keychar isnum 1-5) && ($timer(musict)) mt.ques-ans $iif($keychar != %mt.correct,1)
on *:close:@: if ($target == @musictest) mt.close
alias -l mt.close {
  .timermusict off
  .timermtstart off
  .splay stop
  unset %mt.* %points
}
alias mt.write-pl var %x = 1 | while ($mid($1,%x,1)) || ($mid($1,%x,1) == 0) var %pltext = $iif($width($mid($1,1,%x),tahoma,10) <= $2,$mid($1,1,%x),%pltext), %x = $calc(%x + 1) | return %pltext
alias -l mt.rnd-start {
  .splay stop
  drawrect -fr @musictest $rgb(255,255,255) 1 10 18 190 62
  unset %mt.nums
  var %x = 1
  while (%x <= $iif($mt.pl-info(0) > 5,5,$v1)) {
    :num
    var %num = $r(1,$mt.pl-info(0))
    if ($istok(%mt.nums,%num,32)) goto num
    %mt.nums = $addtok(%mt.nums,%num,32)
    inc %x
  }
  var %x = 1
  while ($gettok(%mt.nums,%x,32)) {
    drawtext -ro @musictest $rgb(0,0,0) tahoma 10 13 $calc(7 + 12 * %x) $mt.write-pl($+(%x,.) $mt.pl-info($ifmatch).title,155)
    inc %x
  }
  :song
  var %rnd = $randtok(%mt.nums,32), %rnd2 = $calc($rand(1,$mt.pl-info(%rnd).length) * 1000)
  if (!$isfile($mt.pl-info(%rnd))) goto song
  set %mt.correct $findtok(%mt.nums,%rnd,32)
  set %points 1000
  .splay $mt.pl-info(%rnd) %rnd2
  .timermusict -m 0 100 mt.timer
}
alias mt.pl-info {
  if (!$isid) {
    if ($hget(musictest)) hfree $ifmatch
    hmake musictest 100
    set %mt.pl-temp $1-
    unset %n
    filter -k $+(",$1-,") mt.filter *
  }
  else return $iif($1 == 0 && !$prop,$hfind(musictest,song*,0,w),$gettok($hget(musictest,song $+ $1),$iif($prop,$replace($prop,length,1,title,2,file,3),3),222))
}
alias -l mt.filter {
  if ($+(#EXTINF:,*,$chr(44),*) iswm $1-) {
    inc %n
    hadd musictest $+(song,%n) $+($gettok($gettok($1-,2,58),1,44),$chr(222),$gettok($1-,2-,44))
    set %mt.temp $true
  }
  elseif (%mt.temp) {
    hadd musictest $+(song,%n) $addtok($hget(musictest,$+(song,%n)),$+($gettok(%mt.pl-temp,1,58),:\,$iif($numtok($1-,92) == 1,$right($nofile(%mt.pl-temp),-3)),$1-),222)
    unset %mt.temp
  }
}
alias -l mt.timer {
  if ($iif(%points,%points,-1) <= 0) {
    drawrect -fr @musictest $rgb(255,255,255) 1 10 18 190 62
    mt.ques-ans 1
    set %points 1000
    drawpbar -pr @musictest 13 4 105 9 0 1 1 $rgb(0,0,0) $rgb(255,255,255) $rgb(0,0,0) $rgb(128,128,128) $rgb(208,208,208)
    .timermusict off
    mt.rnd-start
    return
  }
  dec %points 10
  drawrect -fr @musictest $rgb(255,255,255) 1 160 2 50 12
  drawtext -ro @musictest $rgb($calc(250 - (%points / 4)),$calc(%points / 4),0) tahoma 10 $calc(182 - $width(%points,tahoma,10)) 2 %points
  drawpbar -pr @musictest 13 4 105 9 0 1000 %points $rgb(0,0,0) $rgb(255,255,255) $rgb(0,0,0) $rgb(128,128,128) $rgb(208,208,208)
}
alias -l mt.ques-ans {
  if (!$1) { inc %mt.right | inc %mt.total %points  }
  inc %mt.ques
  .timermusict off
  unset %points
  drawrect -fr @musictest $rgb(255,255,255) 1 13 84 175 12
  drawtext -ro @musictest $rgb(0,0,0) tahoma 10 $calc(100 - ($width(Score: %mt.total $+($chr(40),%mt.right,/,%mt.ques,$chr(41)),tahoma,10) / 2)) 84 Score: %mt.total $+($chr(40),%mt.right,/,%mt.ques,$chr(41))
  mt.rnd-start
}
alias -l randtok return $gettok($1,$rand(1,$numtok($1,$2)),$2)
alias -l drawpbar {
  var %flags = $iif(-* iswm $1,$1), %params = $iif(-* iswm $1,$2-,$1-)
  tokenize 32 %params
  var %len = $round($calc($8 * ($4 / ($7 - $6))),0)
  drawrect $iif(-*r* iswm %flags,-r) $1 $11 1 $2-5
  drawrect $iif(-*r* iswm %flags,-fr,-f) $1 $10 1 $calc($2 + 1) $calc($3 + 1) $calc($4 - 2) $calc($5 - 2)
  if (%len >= 2) {
    drawrect $iif(-*r* iswm %flags,-fr,-f) $1 $9 1 $calc($2 + 1) $calc($3 + 1) $calc(%len - 2) $calc($5 - 2)
    if (-*p* iswm %flags) {
      drawline $iif(-*r* iswm %flags,-r) $1 $13 1 $calc($2  + 1) $calc($3 + $5 - 2) $calc($2 + 1) $calc($3 + 1) $calc($2 + %len - 1) $calc($3 + 1)
      drawline $iif(-*r* iswm %flags,-r) $1 $12 1 $calc($2 + 1) $calc($3 + $5 - 2) $calc($2 + %len - 2) $calc($3 + $5 - 2) $calc($2 + %len - 2) $calc($3 + 1)
    }
  }
}
